import { createNodeParser } from './creator';
import { convertToNodes } from '.';
const decorationRegExp = /\[[!"#%&'()*+,-./{|}<>_~]+ (?:\[[^[\]]+\]|[^\]])+\]/;
const createDecorationNode = (target, opts) => {
    const separatorIndex = target.indexOf(' ');
    const decoChars = target.substring(1, separatorIndex);
    const text = target.substring(separatorIndex + 1, target.length - 1);
    const decoSet = new Set(decoChars);
    if (decoSet.has('*')) {
        const asteriskCount = decoChars.split('*').length - 1;
        decoSet.delete('*');
        decoSet.add(`*-${Math.min(asteriskCount, 10)}`);
    }
    return {
        type: 'decoration',
        decos: Array.from(decoSet),
        nodes: convertToNodes(text, { ...opts, nested: true })
    };
};
export const DecorationNodeParser = createNodeParser(createDecorationNode, {
    parseOnNested: false,
    parseOnQuoted: true,
    patterns: [decorationRegExp]
});
//# sourceMappingURL=DecorationNode.js.map