"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertToCodeBlock = exports.isCodeBlockComponent = void 0;
const isCodeBlockComponent = (packedBlockComponent) => packedBlockComponent.type === 'codeBlock';
exports.isCodeBlockComponent = isCodeBlockComponent;
const convertToCodeBlock = (blockComponent) => {
    const { components } = blockComponent;
    const [head, ...body] = components;
    const { indent, text } = head;
    const fileName = text.replace(/^\s*code:/, '');
    return {
        indent,
        type: 'codeBlock',
        fileName,
        content: body
            .map((component) => component.text.substring(indent + 1))
            .join('\n')
    };
};
exports.convertToCodeBlock = convertToCodeBlock;
//# sourceMappingURL=CodeBlock.js.map