"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTitle = exports.parse = void 0;
const block_1 = require("./block");
const BlockComponent_1 = require("./block/BlockComponent");
const PackedBlockComponent_1 = require("./block/PackedBlockComponent");
const parse = (input, { hasTitle = true } = {}) => {
    const blockComponents = BlockComponent_1.convertToBlockComponents(input);
    const packedBlockComponents = PackedBlockComponent_1.packBlockComponents(blockComponents, {
        hasTitle
    });
    return packedBlockComponents.map(block_1.convertToBlock);
};
exports.parse = parse;
const getTitle = (input) => {
    const match = /^\s*\S.*\s*$/m.exec(input);
    return match !== null ? match[0].trim() : 'Untitled';
};
exports.getTitle = getTitle;
//# sourceMappingURL=parse.js.map